/*
	Copyright by shredded 7 AUG 2009

	Bitness.cpp is the main program source

	This file is part of Bitness.

    Bitness is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bitness is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bitness.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "Bitness.h"
 
int	WINAPI	WinMain(HINSTANCE hInstance,HINSTANCE pInstance,
			LPSTR pCmdLine,int cmdShow)
{ 
	hInst = hInstance;
 
	if (!regWindow())
	{
		return(0);
	}

	if (!makeWindow())
	{
		return(0);
	}

	while (GetMessage(&msg,NULL,NULL,NULL))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return(0);
}

bool	regWindow()
{
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = (WNDPROC) &wndProc;	
	wc.cbClsExtra = NULL;
	wc.cbWndExtra = NULL;
	wc.hInstance  = hInst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE + 1;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "Bitness";
	wc.hIconSm = NULL;

	return(RegisterClassEx(&wc));
}

bool	makeWindow()
{
	HWND	win1 = CreateWindow("Bitness","Is File 32 or 64 bit",
			WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU,
			CW_USEDEFAULT,0,250,300,NULL,NULL,hInst,NULL);

	if (win1 == NULL)
	{
		return(false);
	}
	else
	{
		ShowWindow(win1,SW_SHOW);
		UpdateWindow(win1);

		return(true);
	}
}

LRESULT		CALLBACK	wndProc(HWND hWnd,UINT uMsg,WPARAM wParam,
					LPARAM lParam)
{
	HDC			hdc;
	PAINTSTRUCT	ps;

	switch(uMsg)
	{
	case	WM_DESTROY:

		PostQuitMessage(0);
		break;

	case	WM_CREATE:

		hwnd = hWnd;

		filename = new WCHAR[64];

		font1 = CreateFont(14,0,0,0,400,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,"Veranda");

		edit1 = CreateWindow("EDIT",0,WS_CHILD | WS_BORDER | ES_READONLY,
							40,70,160,20,
							hWnd,(HMENU) 0x4000,hInst,NULL);

		static1 = CreateWindow("STATIC","Drag n Drop File To Test",WS_CHILD,
							45,20,80,36,
							hWnd,(HMENU) 0x00,hInst,NULL);

		static2 = CreateWindow("STATIC","Is PE file",WS_CHILD,
							40,140,70,20,
							hWnd,(HMENU) 0x00,hInst,NULL);

		static3 = CreateWindow("STATIC","",WS_CHILD,
							120,140,50,20,
							hWnd,(HMENU) 0x00,hInst,NULL);

		static4 = CreateWindow("STATIC","Bits",WS_CHILD,
							40,180,70,20,
							hWnd,(HMENU) 0x00,hInst,NULL);

		static5 = CreateWindow("STATIC","",WS_CHILD,
							120,180,50,20,
							hWnd,(HMENU) 0x00,hInst,NULL);


		SendMessage(edit1,WM_SETFONT,(WPARAM) font1,0);
		SendMessage(static1,WM_SETFONT,(WPARAM) font1,0);
		SendMessage(static2,WM_SETFONT,(WPARAM) font1,0);
		SendMessage(static3,WM_SETFONT,(WPARAM) font1,0);
		SendMessage(static4,WM_SETFONT,(WPARAM) font1,0);
		SendMessage(static5,WM_SETFONT,(WPARAM) font1,0);

		ShowWindow(edit1,SW_SHOW);
		ShowWindow(static1,SW_SHOW);
		ShowWindow(static2,SW_SHOW);
		ShowWindow(static4,SW_SHOW);

		target = new Target(hwnd);
		target->SetOwner(hwnd);

		RegisterDragDrop(edit1,target);

		break;

	case	0x3000:

		file = target->GetFileName();

		removePath();

		SendMessageW(edit1,WM_SETTEXT,0,(LPARAM) filename);

		checkFile();

		break;

	default:

		return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	}

	return(0);
}

void	removePath()
{
	for (int i=wcslen(file);i>0;i--)
	{
		if (file[i] == L'\\')
		{
			i++;		// for removing '\'

			memcpy(filename,&file[i],(wcslen(&file[i]) + 1) * 2);
			return;
		}
	}

	memcpy(filename,file,(wcslen(file) + 1) * 2);
}

void	checkFile()
{
	HANDLE	hFile;
	ULONG	Bytes;

	int		address;
	int		sigPE;
	USHORT	sigBits;

	hFile = CreateFileW(file,GENERIC_READ,NULL,NULL,OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,NULL);

	if (hFile == INVALID_HANDLE_VALUE)
	{
		MessageBox(hwnd,"Invalid filename",0,0);
		return;
	}

	SetFilePointer(hFile,0x3c,NULL,FILE_BEGIN);

	ReadFile(hFile,&address,4,&Bytes,NULL);

	SetFilePointer(hFile,address,NULL,FILE_BEGIN);

	ReadFile(hFile,&sigPE,4,&Bytes,NULL);

	ReadFile(hFile,&sigBits,2,&Bytes,NULL);

	CloseHandle(hFile);

	if (sigPE == 0x00004550)
	{
		SendMessage(static3,WM_SETTEXT,0,(LPARAM) "Yes");
	}
	else
	{
		SendMessage(static3,WM_SETTEXT,0,(LPARAM) "No");
	}

	if (sigBits == 0x014c)
	{
		SendMessage(static5,WM_SETTEXT,0,(LPARAM) "32 Bit");
	}
	else if (sigBits == 0x8664 || sigBits == 0x200)
	{
		SendMessage(static5,WM_SETTEXT,0,(LPARAM) "64 Bit");
	}
	else
	{
		SendMessage(static5,WM_SETTEXT,0,(LPARAM) "Invalid");
	}

	ShowWindow(static3,SW_SHOW);
	ShowWindow(static5,SW_SHOW);

	
	
}