/*
	Copyright by shredded 7 AUG 2009

	drop.cpp is the drag n drop implementation

	This file is part of Bitness.

    Bitness is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bitness is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bitness.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef	drop_H
#define	drop_H

#include	"drop.h"

Target::Target(HWND hWnd)
{
	OleInitialize(0);
}

Target::~Target()
{
	OleUninitialize();
}

ULONG	__stdcall	Target::AddRef()
{
	return	InterlockedIncrement(&m_lRefCount);
}
ULONG	__stdcall	Target::Release()
{
	LONG	count = InterlockedDecrement(&m_lRefCount);

	if (count == 0)
	{
		delete(this);
		return(0);
	}
	else
	{
		return(count);
	}
}
HRESULT	__stdcall	Target::QueryInterface(REFIID iid,void** ppvObj)
{
	if (iid == IID_IDropTarget || iid == IID_IUnknown)
	{
		AddRef();
		*ppvObj = this;

		return(S_OK);
	}
	else
	{
		*ppvObj = 0;

		return(E_NOINTERFACE);
	}
}	

HRESULT	__stdcall	Target::DragEnter(IDataObject* pDataObject,
					DWORD grfKeyState,
					POINTL pt,
					DWORD* pdwEffect)
{
	

	*pdwEffect = DROPEFFECT_COPY;
	return(S_OK);
}

HRESULT	__stdcall	Target::DragOver(DWORD grfKeyState,
					POINTL pt,
					DWORD*	pdwEffect)
{
	*pdwEffect = DROPEFFECT_COPY;
	return(S_OK);
}

HRESULT	__stdcall	Target::DragLeave()
{
	return(S_OK);
}

HRESULT	__stdcall	Target::Drop(IDataObject* pDataObject,
					DWORD grfKeyState,
					POINTL pt,
					DWORD* pdwEffect)
{
	
	/////////////////CF_HDROP	&& TYMED_HGLOBAL
	

	fetc = new FORMATETC; 
		
	smed = new STGMEDIUM;
	
	fetc->cfFormat = CF_HDROP;
	fetc->ptd = NULL;
	fetc->dwAspect = DVASPECT_CONTENT;
	fetc->lindex = -1;
	fetc->tymed = TYMED_HGLOBAL;
	
	if (S_OK == pDataObject->GetData(fetc,smed))
	{
		StartMem = GlobalLock(smed->hGlobal);
	}
	else
	{
		return(S_FALSE);
	}

	*pdwEffect = DROPEFFECT_COPY;

	SendMessage(owner,0x3000,0,0);
	
	return(S_OK);
}

void	Target::SetOwner(HWND ownerIn)
{
	owner = ownerIn;
}

WCHAR*	Target::GetFileName()
{
	
	return((WCHAR*) StartMem + 0x0a);
}

#endif