/*
	Copyright by shredded 7 AUG 2009

	Drop.h is the drag n dreop header file

	This file is part of Bitness.

    Bitness is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bitness is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bitness.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <windows.h>
#include <oleidl.h>

#include <stdio.h>

class	Target : public IDropTarget
{
public:

	Target(HWND hWnd);
	~Target();

	HRESULT	__stdcall	QueryInterface(REFIID iid,void** ppvObj);
	ULONG	__stdcall	AddRef(void);
	ULONG	__stdcall	Release(void);

	HRESULT	__stdcall	DragEnter(IDataObject* pDataObject,
					DWORD grfKeyState,
					POINTL pt,
					DWORD* pdwEffect);

	HRESULT	__stdcall	DragOver(DWORD grfKeyState,
					POINTL pt,
					DWORD*	pdwEffect);

	HRESULT	__stdcall	DragLeave();	

	HRESULT	__stdcall	Drop(IDataObject* pDataObject,
					DWORD grfKeyState,
					POINTL pt,
					DWORD* pdwEffect);

	WCHAR*	GetFileName();

	void	SetOwner(HWND ownerIn);
	

private:

	LONG	m_lRefCount;

	FORMATETC*	fetc;
	STGMEDIUM*	smed;

	HWND		owner;

	void*		StartMem;
	
};

//#endif
